fixes and alert improvements
[distro-setup] / system-status
1 #!/bin/bash
2 # Copyright (C) 2019 Ian Kelling
3 # SPDX-License-Identifier: AGPL-3.0-or-later
4
5 # usage: runs once every 15 seconds unless any args are passed, or we
6 # then just runs once. On battery power, run once per minute.
7
8 if [ -z "$BASH_VERSION" ]; then echo "error: shell is not bash" >&2; exit 1; fi
9
10 if [[ $EUID != 1000 ]]; then
11 echo "$0: error, expected to be user 1000"
12 exit 1
13 fi
14
15 source /a/bin/errhandle/err
16 status_file=/dev/shm/iank-status
17
18 shopt -s nullglob
19 shopt -s dotglob
20 shopt -s extglob
21
22 for p in ~/.gem/ruby/*/bin; do
23 PATH="$PATH:$p"
24 done
25
26
27 verbose=false
28 if [[ $1 ]]; then
29 verbose=true
30 fi
31 v() {
32 if $verbose; then
33 printf "%s\n" "$*"
34 fi
35 }
36 p() { printf "%s\n" "$*"; }
37 # log-once COUNT NAME [MESSAGE]
38 lo() {
39 if type -p ifne &>/dev/null; then
40 /usr/local/bin/log-once "$@" | ifne mail -s "$HOSTNAME: system-status $2" root@localhost
41 fi
42 }
43
44 loday() {
45 if type -p ifne &>/dev/null; then
46 /usr/local/bin/log-once "$@" | ifne mail -s "$HOSTNAME: system-status $2" daylert@iankelling.org
47 fi
48 }
49
50 # todo, consider migrating some of these alerts into prometheus
51 write-status() {
52 chars=("${first_chars[@]}")
53
54 services=( epanicclean )
55 case $HOSTNAME in
56 bk|je|li) : ;;
57 *)
58 services+=(
59 systemstatus
60 btrfsmaintstop
61 dynamicipupdate
62 )
63 bads=()
64 if systemctl show -p SubState --value ${services[@]} | egrep -v '^(running|)$' &>/dev/null; then
65 for s in ${services[@]}; do
66 if [[ $(systemctl show -p SubState --value $s 2>&1) != running ]]; then
67 bads+=($s)
68 fi
69 done
70 chars+=(MYSERS)
71 fi
72 p ${bads[*]} | lo -240 mysers
73 ;;
74 esac
75
76 case $HOSTNAME in
77 kd)
78 services=(
79 prometheus-node-exporter
80 prometheus-alertmanager
81 prometheus
82 )
83 bads=()
84 if systemctl show -p SubState --value ${services[@]} | egrep -v '^(running|)$' &>/dev/null; then
85 for s in ${services[@]}; do
86 if [[ $(systemctl show -p SubState --value $s 2>&1) != running ]]; then
87 bads+=($s)
88 fi
89 done
90 chars+=(PROM)
91 fi
92 p ${bads[*]} | lo -240 prom
93 ;;
94 esac
95
96
97 if [[ -e /a/bin/bash_unpublished/source-state ]]; then
98 # /a gets remounted due to btrbk, ignore error code for file doesnt exist
99 source /a/bin/bash_unpublished/source-state || [[ $? == 1 ]]
100 fi
101 if [[ $MAIL_HOST == "$HOSTNAME" ]]; then
102
103 bouncemsg=
104 glob=(/m/md/bounces/new/*)
105 if [[ -e ${glob[0]} ]]; then
106 chars+=(BOUNCE)
107 bouncemsg="message in /m/md/bounces/new"
108 fi
109 p $bouncemsg | loday -1 bounce
110 # emails without the S (seen) flag. this only checks the last flag,
111 # but its good enough for me.
112 glob=(/m/md/alerts/{new,cur}/!(*,S))
113 if [[ -e ${glob[0]} ]]; then
114 chars+=(A)
115 fi
116
117 glob=(/m/md/daylert/{new,cur}/!(*,S))
118 if [[ -e ${glob[0]} ]]; then
119 chars+=(DAY)
120 fi
121
122 bbkmsg=
123 if [[ $(systemctl is-active btrbk.timer) != active ]]; then
124 chars+=(BTRBK.TIMER)
125 bbkmsg="not enabled"
126 fi
127 p "$bbkmsg" | lo -480 btrbk.timer
128
129 ## check if last snapshot was within an hour
130 vol=o
131 # this section generally copied from btrbk scripts, but
132 # this part modified to speed things up by about half a second.
133 # I'm not sure if its quite as reliable, but it looks pretty safe.
134 # Profiled it using time and also adding to the top of the file:
135 # set -x
136 # PS4='+ $(date "+%2N") '
137 # allow failure in case there are no snapshots yet.
138 # shellcheck disable=SC2012
139 shopt -u nullglob
140 files=(/mnt/root/btrbk/$vol.20*)
141 shopt -s nullglob
142 snaps=()
143 if (( ${#files[@]} )); then
144 snaps=($(ls -1avdr "${files[@]}" 2>/dev/null |head -n1 || : ))
145 fi
146 now=$EPOCHSECONDS
147 maxtime=0
148 for s in ${snaps[@]}; do
149 file=${s##*/}
150 t=$(date -d $(sed -r 's/(.{4})(..)(.{5})(..)(.*)/\1-\2-\3:\4:\5/' <<<${file#$vol.}) +%s)
151 if (( t > maxtime )); then
152 maxtime=$t
153 fi
154 done
155 snapshotmsg=
156 if (( maxtime < now - 4*60*60 )); then
157 chars+=(OLD-SNAP)
158 snapshotmsg="/o snapshot older than 4 hours"
159 fi
160 p "$snapshotmsg" | lo -1 old-snapshot
161
162
163 # commented out, only using timetrap retrospectively.
164 # # clock us out in timetrap if are idle too long
165 # if [[ -e /p/.timetrap.db ]]; then
166 # export DISPLAY=:0
167 # if type -p xprintidle &>/dev/null && xidle=$(xprintidle 2>/dev/null); then
168 # if [[ $xidle == [0-9]* ]]; then
169 # sheet=$(sqlite3 /p/.timetrap.db "select sheet from entries where end is NULL;")
170 # idle=300000
171 # if [[ $sheet == w ]]; then
172 # idle=900000
173 # fi
174 # if [[ $sheet && $xidle -gt $idle ]]; then
175 # timetrap out
176 # fi
177 # fi
178 # fi
179 # fi
180
181 fi
182
183 if ip l show tunfsf &>/dev/null; then
184 # this is for tracking dns over tls issue, which
185 # fixvpndns() in brc2 fixes.
186 stat=$(resolvectl dnsovertls tunfsf 2>/dev/null ||: )
187 read _ _ _ istls <<<"$stat"
188 case $istls in
189 no) : ;;
190 *)
191 printf "%s\n" "$istls" | ts >> /tmp/istls.log
192 chars+=("T:$istls")
193 ;;
194 esac
195 fi
196
197 # We do this once every 5 minutes, since this is not a grave problem.
198 # For formatted elisp, see /b/ds/unsaved-buffers.el
199 elisp='(format "%s" (-reduce-from (lambda (acc buf) (let ((bpath (buffer-file-name buf))) (if (and bpath (buffer-modified-p buf)) (cons bpath acc ) acc))) nil (buffer-list)))'
200 if [[ ! $last_emacs_check || $emacsfiles ]] || (( last_emacs_check < EPOCHSECONDS - 300 )); then
201 if pgrep -G iank -u iank -f 'emacs --daemon' &>/dev/null; then
202 # i dun care if this fails
203 emacsfiles="$(timeout 1 emacsclient --eval "$elisp"| sed '/^"nil"$/d;s/^"(/E: /;s/)"$//' ||:)"
204 if [[ $emacsfiles ]]; then
205 chars+=("$emacsfiles")
206 fi
207 fi
208 last_emacs_check=$EPOCHSECONDS
209 fi
210
211
212 glob=(/nocow/btrfs-stale/*)
213 if [[ -e ${glob[0]} ]]; then
214 chars+=(STALE)
215 fi
216 var_mail_msg=
217 if [[ $(find /var/mail -type f \! -empty -print -quit) ]]; then
218 var_mail_msg="message in /var/mail"
219 fi
220 p $var_mail_msg | loday -1 var_mail
221
222 # early in install process, we dont have permission yet for exiqgrep.
223 # 1100 helps allow for system restarts
224 qlen=$(/usr/sbin/exiqgrep -o 1100 -c -b | awk '{print $1}') ||:
225 qmsg=
226 if ((qlen)); then
227 qmsg="queue length $qlen"
228 chars+=("q $qlen")
229 fi
230 case $HOSTNAME in
231 # No point in emailing about the mailq on a host where we don't
232 # check email.
233 $MAIL_HOST)
234 p $qmsg | loday -120 qlen
235 ;;
236 esac
237
238 begin=false
239
240 if ! make -C /b/ds -q ~/.local/distro-begin 2>/dev/null || [[ $(<~/.local/distro-begin) != 0 ]]; then
241 begin=true
242 fi
243
244 end=false
245 if ! make -C /b/ds -q ~/.local/distro-end 2>/dev/null || [[ $(<~/.local/distro-end) != 0 ]]; then
246 end=true
247 fi
248
249 # these conditions are so we dont have an overly verbose prompt
250 if $begin && $end; then
251 chars+=(D)
252 elif $begin; then
253 chars+=(DB)
254 elif $end; then
255 chars+=(DE)
256 else
257 f=~/.local/conflink
258 # shellcheck disable=SC2043
259 for _ in 1; do
260 if [[ -e $f ]]; then
261 now=$EPOCHSECONDS
262 fsec=$(stat -c%Y $f)
263 # the / 60 makes it 0-59 seconds less strict, +1 to help make sure we
264 # dont have any false positives.
265 fmin=$(( (fsec - now + 1 ) / 60 ))
266 fminplus=$(( fmin + 60*24 ))
267 # Filesystem files get copied, so find any newer than the last run.
268 # The rest are hueristics:
269 # Given the last time we added a file in git, is that newer than the last conflink run.
270 # Given new files not added to git, were they modified more recently than the last conflink? but,
271 # push their modification time back by a day so we can develop them before needing to add them to git.
272
273 all_dirs=({/a/bin/ds,/p/c}{/filesystem,/machine_specific/$HOSTNAME/filesystem})
274 # This part is copied from conflink
275 for x in /p/c/machine_specific/*.hosts /a/bin/ds/machine_specific/*.hosts; do
276 if grep -qxF $HOSTNAME $x; then all_dirs+=( ${x%.hosts} ); fi
277 done
278
279 # Just because i forget a lot, -mmin -NUM means files modified <= NUM minutes ago
280 if (( fmin < 0 )) && [[ $(find ${all_dirs[@]} -mmin $fmin -type f -print -quit 2>/dev/null) ]]; then
281 v conflink newer filesystem files
282 chars+=(CONFLINK)
283 break
284 fi
285
286 for d in /a/bin/distro-setup /p/c; do
287 [[ -d $d ]] || continue
288 cd $d
289 if [[ ! -e .git ]]; then
290 # some hosts i dont push all of /p/c
291 continue
292 fi
293 if (( $(date -d "$(git log --diff-filter=ACR --format=%aD -1)" +%s) > fsec )); then
294 v conflink: newer files checked in to git
295 chars+=(CONFLINK)
296 break
297 fi
298
299 untracked=()
300 while read -r l; do
301 untracked+=("$l")
302 done < <(git ls-files -o --exclude-standard)
303 if [[ ${untracked[0]} && $(find "${untracked[@]}" -mmin $fminplus -type f -print -quit) ]]; then
304 v conflink: untracked in $d
305 chars+=(CONFLINK)
306 break
307 fi
308 done
309 cd /
310
311 fi
312 if [[ ! -e $f || $(<$f) != 0 ]]; then
313 v conflink: last run not found or failed
314 chars+=(CONFLINK)
315 break
316 fi
317 done
318 fi
319
320 # if [[ $(grep -v "exim user lost privilege for using -C option" /var/log/exim4/paniclog 2>/dev/null ||:) ]]; then
321 if [[ -s /var/log/exim4/paniclog ]]; then
322 chars+=("PANIC!")
323 # leave it up to epanic-clean to send email notification
324 fi
325
326 if [[ ! -e $status_file || -w $status_file ]]; then
327 if [[ -e /a/bin/bash_unpublished/source-state ]]; then
328 cat /a/bin/bash_unpublished/source-state >$status_file
329 fi
330
331 if [[ ${chars[*]} ]]; then
332 echo "ps_char=\"${chars[*]} \$ps_char\"" >>$status_file
333 fi
334 fi
335 }
336 # use this if we want to do something just once per minute
337 first_chars=()
338
339
340 write-status
341 if [[ $1 ]]; then
342 cat $status_file
343 exit 0
344 fi
345
346 main-loop() {
347 while true; do
348 power=true
349 if [[ -e /sys/class/power_supply/AC/online && $(</sys/class/power_supply/AC/online) == 0 ]]; then
350 power=false
351 fi
352 wait=15
353 if ! $power; then
354 wait=60
355 fi
356
357 sleep $wait
358 write-status
359 done
360 }
361
362 # ensure our long operations are one line so we are not prone errors
363 # from this file being modified.
364 main-loop